// pages/apply/approval/approval.js
import * as UTIL from '../../../utils/util.js';
import * as API from '../../../utils/API.js';
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isIPX: app.globalData.isIPX,
    steps: [
      {
        assigneeName: '同意',
        activityName: '测试测试',
        durationInMillis: '描述信息',
        endTime: '2022-01-02',
        comment: '同意',
        type: '1'
      },
      {
        assigneeName: '申请中',
        activityName: '测试测试',
        durationInMillis: '描述信息',
        endTime: '2022-01-02',
        comment: '同意',
        type: '2'
      },
      {
        assigneeName: '驳回',
        activityName: '测试测试',
        durationInMillis: '描述信息',
        endTime: '2022-01-02',
        comment: '同意',
        type: '3'
      },
      {
        assigneeName: '步骤四',
        activityName: '测试测试',
        durationInMillis: '描述信息',
        endTime: '2022-01-02',
        comment: '同意'
      },
    ],
    //事务总表对象
    item:{},
    itemId:13,
    active:0,
    result:[],
    show:false,
    showPopup:false,
    templateList:[],
    templateDetailList:[],
    groups:[],
    villages:[],
    towns:[],
    temName:"",
    temId:""
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    //this.getApprovalItemList();
    this.groupList();
    this.townList();
    this.villageList();
    this.getApprovalItemsById();
   // this.getApprovalItemList();
  },
  getApprovalItemsById(){
    let _this = this
    let url = API.URL_GET_APPROVALITEMSBYID+this.data.itemId
    wx.request({
      url,
      method:"GET",
      timeout: 60000,
      header: {
        'Authorization':'Bearer '+getApp().globalData.userInfo.token
      },
      success: function (response) {
        _this.setData({item:response.data.data})
        if(_this.data.item.templateId!=""&&_this.data.item.templateId!=null){
          _this.setData({item:response.data.data,temId:_this.data.itemId})
          let d = {
            templateId : _this.data.item.templateId,
            orderByColumn:"id",
            isAsc:"asc"
          }
          UTIL.httpRequest(API.URL_GET_TEMPLATEDETAIL, d, {
            success: (r) => {
              if (r.code == API.SUCCESS_CODE) {
                _this.setData({templateDetailList:r.rows});
                let list = []
                  r.rows.map(rr => {
                    list.push(rr.userId+"")
                  })
                  _this.setData({result:list})
              }
            }
          })
        }else {
          _this.getApprovalItemList()
        }
      }
    })
  },
  inputTem:function(e){
      this.setData({temName:e.detail.value})
  },
  confirmTem:function(e){
    let data={
      approvalTemplate:{
        name:this.data.temName,
        type:1,
        dataType:0
      },
      approvalTemplateDetailList:this.data.templateDetailList,
      method:"POST"
    }
    UTIL.httpRequest(API.URL_POST_MOBILEADD,data,{
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          let list = this.data.templateList 
          list.push(res.data)
          this.setData({
            temId:res.data.id,
            templateList:list,
            temName:"",
            showPopup:false
          });
        }
      }
    })
  },
  cancelTem:function(e){
    this.setData({temName:"",showPopup:false});
  },
  upItem:function(e){
    let index = e.currentTarget.dataset.id
    let item = this.data.templateDetailList[index]
    let list = this.data.templateDetailList
    if(index>0&&index<=list.length){
      list.splice(index,1)
      list.splice(index-1,0,item)
      for(let i = 0;i< list.length;i++){
        list[i].name = i+1
      }
      this.setData({templateDetailList:list});
    }    
  },
  downItem:function(e){
    let index = e.currentTarget.dataset.id
    let item = this.data.templateDetailList[index]
    let list = this.data.templateDetailList
    if(index>=0&&index<list.length){
      list.splice(index,1)
      list.splice(index+1,0,item)
      for(let i = 0;i< list.length;i++){
        list[i].name = i+1
      }
      this.setData({templateDetailList:list});
    }  
  },
  getApprovalItemList:function(){
    let data={
        dataType:0,
        pageNum:1,
        pageSize:50
    }
    UTIL.httpRequest(API.URL_GET_TEMPLATELIST, data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({templateList:res.rows});
          if(res.total>0){
            let d = {
              templateId : res.rows[0].id,
              orderByColumn:"id",
              isAsc:"asc"
            }
            UTIL.httpRequest(API.URL_GET_TEMPLATEDETAIL, d, {
              success: (r) => {
                if (r.code == API.SUCCESS_CODE) {
                  this.setData({templateDetailList:r.rows});
                  let list = []
                  r.rows.map(rr => {
                    list.push(rr.userId+"")
                  })
                  this.setData({result:list})
                }
              }
            })
          } 
        }
      }
    })
  },
  chooseTemplate:function(e){
    let data = {
      templateId : e.currentTarget.dataset.id,
      orderByColumn:"id",
      isAsc:"asc"
    }
    UTIL.httpRequest(API.URL_GET_TEMPLATEDETAIL, data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({templateDetailList:res.rows});
          this.closeBox();
        }
      }
    })
  },
  deleteTemplate:function(e){
    let ids = [e.currentTarget.dataset.id]
    let url = API.URL_GET_MOBILEREMOVE+ids
    let _this = this
    wx.request({
      url,
      method:"GET",
      timeout: 60000,
      header: {
        'Authorization':'Bearer '+getApp().globalData.userInfo.token
      },
      success: function (response) {
        _this.getApprovalItemList()
      }
    })
  },
  townList:function(){
    let _this = this
    let url = API.URL_GET_TOWNINFOBYDEPTID+0
    wx.request({
      url,
      method:"GET",
      timeout: 60000,
      header: {
        'Authorization':'Bearer '+getApp().globalData.userInfo.token
      },
      success: function (response) {
        let d = {
          deptId:response.data.data.deptId,
          deptLevel:3
        }
        UTIL.httpRequest(API.URL_GET_USERLIST,d,{
          success: (res) => {
            if (res.code == API.SUCCESS_CODE) {
              console.log(res);
              _this.setData({towns:res.rows});
            }
          }
        })
      }
    })
  },
  groupList:function(){
      let data = {
        deptId : 187,
        deptLevel:1
      }
    UTIL.httpRequest(API.URL_GET_USERLIST,data ,{
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({groups:res.rows});
        }
      }
    })
 
  },
  villageList:function(){
    let data = {
      deptId : 187,
      deptLevel:2
    }
  UTIL.httpRequest(API.URL_GET_USERLIST,data ,{
    success: (res) => {
      if (res.code == API.SUCCESS_CODE) {
        this.setData({villages:res.rows});
      }
    }
  })
},
  onChange(event) {
    let _this = this
    this.setData({result:event.detail})
    this.setData({templateDetailList:[]})
      let list = _this.data.templateDetailList
       for (let j in event.detail){
         let str = event.detail[j]
         for(let i in _this.data.groups){
          if(_this.data.groups[i].userId == str){
            let sin = _this.data.groups[i]
            list.push(sin)
            _this.setData({templateDetailList:list})
          }
      }
        for(let i in _this.data.villages){
          if(_this.data.villages[i].userId == str){
            let sin = _this.data.villages[i]
            list.push(sin)
            _this.setData({templateDetailList:list})
          }
      }
        for(let i in _this.data.towns){
          if(_this.data.towns[i].userId == str){
            let sin = _this.data.towns[i]
            list.push(sin)
            _this.setData({templateDetailList:list})
          }
      }
       }
  },
  save:function(){
    let _this = this
    let list = this.data.templateDetailList
    list = list.filter(function(e,i,s){
      s[i].name = i+1
        return true
    })
    if(this.data.temId==""||this.data.temId==null){
      let data={
        approvalTemplate:{
          name:this.data.temName,
          type:1,
          dataType:1
        },
        approvalTemplateDetailList:list,
        method:"POST"
      }
      UTIL.httpRequest(API.URL_POST_MOBILEADD,data,{
        success: (res) => {
          if (res.code == API.SUCCESS_CODE) {
            let list = this.data.templateList 
            list.push(res.data)
            this.setData({
              temId:res.data.id,
              templateList:list,
              temName:""
            });
            let item_ = this.data.item
            item_.templateId = res.data.id
            item_.method = "POST"
            UTIL.httpRequest(API.URL_POST_APPROVALITEMSEDIT,item_,{
              success: (res) => {
                if (res.code == API.SUCCESS_CODE) {
                  wx.showToast({
                    title: "暂存成功！",
                    duration: 2000,
                    icon:"success"
                  })
                }
              }
            })
          }
        }
      })
    }else{
        let url = API.URL_POST_TEMPLATEEDIT
        wx.request({
          url,
          data: list,
          method:"POST",
          timeout: 60000,
          header: {
            'Authorization':'Bearer '+getApp().globalData.userInfo.token
          },
          success: function (response) {
            wx.showToast({
              title: "暂存成功！",
              duration: 2000,
              icon:"success"
            })
          },
        })
    }
  },
  submit:function(){
    let _this = this
    if(this.data.temId==""||this.data.temId==null){
      let data={
        approvalTemplate:{
          name:this.data.temName,
          type:1,
          dataType:1
        },
        approvalTemplateDetailList:this.data.templateDetailList,
        method:"POST"
      }
      UTIL.httpRequest(API.URL_POST_MOBILEADD,data,{
        success: (res) => {
          if (res.code == API.SUCCESS_CODE) {
            let list = this.data.templateList 
            list.push(res.data)
            this.setData({
              temId:res.data.id,
              templateList:list,
              temName:""
            });
            let item_ = this.data.item
            item_.templateId = res.data.id
            item_.method = "POST"
            UTIL.httpRequest(API.URL_POST_APPROVALITEMSEDIT,item_,{
              success: (res) => {
                if (res.code == API.SUCCESS_CODE) {
                  _this.requestSubmit()
                }
              }
            })
          }
        }
      })
    }else{
        let url = API.URL_POST_TEMPLATEEDIT
        wx.request({
          url,
          data: _this.data.templateDetailList,
          method:"POST",
          timeout: 60000,
          header: {
            'Authorization':'Bearer '+getApp().globalData.userInfo.token
          },
          success: function (response) {
           _this.requestSubmit()
          },
        })
    }
  },
  requestSubmit:function(){
    let url = API.URL_POST_APPROVALITEMSSUBMIT+this.data.item.id+"/"+this.data.item.templateId
      wx.request({
        url,
        method:"POST",
        timeout: 60000,
        header: {
          'Authorization':'Bearer '+getApp().globalData.userInfo.token
        },
        success: function (r) {
          wx.showToast({
            title: "提交成功！",
            duration: 2000,
            icon:"success"
          })
        },
      })
  },
  openBox:function(){
    var that = this ;
    that.setData({
      show: true,
    })
  },
  closeBox:function(){
    var that = this ;
    that.setData({
      show: false
    })
  },
  showPopup() {
    this.setData({ 
      showPopup: true,
      temName:""
     });
  },

  onClose() {
    this.setData({ showPopup: false});
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})