// pages/apply/paymentTemplate/paymentTemplate.js
import * as UTIL from '../../../utils/util.js';
import * as API from '../../../utils/API.js';
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isIPX: app.globalData.isIPX,
    show: false,
    countMoney:0,
    form:{},
    SJimage: [],
    FPimage: [],
    QTimage: [],
    fileForm:[],
  },
  showPopup() {
    this.setData({ show: true });
  },
  bindNameInput(even){
    this.setData({
      ["form.approvalItemTemplate.templateName"]:even.detail.value
    })
  },
  goSubmit(e){
    var that = this;
    if(e.currentTarget.dataset.type == 1){
      if(that.data.form.approvalItemTemplate.templateName == ''){
        UTIL.showToastNoneIcon('请输入模板名称！');
        return;
      }
    }
    if(e.currentTarget.dataset.type == 3){
      for (let i = 0; i < that.data.form.transfers.length; i++) {
       that.data.form.transfers[i].approvalMode = '2';
      }
       that.data.form.approvalItemTemplate.dataType = e.currentTarget.dataset.type
    }
    that.data.form.method = 'POST';
    that.data.form.approvalItemTemplate.dataType = e.currentTarget.dataset.type;
    that.data.form.approvalItemTemplate.id = null;
    for (let i = 0; i < that.data.form.transfers.length; i++) {
      that.data.form.transfers[i].id = null;
    }
    console.log(that.data.form);
    UTIL.httpRequest(API.URL_GET_SAVE, that.data.form, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          for (let j = 0; j < res.data.transfers.length; j++) {
            for (let i = 0; i < that.data.form.transfers[j].fileForm.length; i++) {
              that.data.form.transfers[j].fileForm[i].tableId =  res.data.transfers[j].id
              const element = that.data.form.transfers[j].fileForm[i];
              wx.uploadFile({
                url: API.URL_GET_UPLOAD,
                filePath: element.file,
                name: 'file',
                header: {
                  "Content-Type": "multipart/form-data",//记得设置
                  "chartset":"utf-8",
                  'Authorization':'Bearer '+getApp().globalData.userInfo.token
                },
                formData:element,
                success (response){
                  console.log(res);
                  if((j+1) == that.data.form.transfers.length && (i+1) == that.data.form.transfers[j].fileForm.length && e.currentTarget.dataset.type == 0){
                    wx.navigateTo({
                      url: '/pages/apply/approval/approval?id='+res.data.id,
                    })
                  }
                  if((j+1) == that.data.form.transfers.length && (i+1) == that.data.form.transfers[j].fileForm.length && e.currentTarget.dataset.type != 0){
                    UTIL.showToastNoneIcon('操作成功！');
                    that.back();
                  }
                },
                fail(res){
                  console.log(res)
                }
              })
            }
           }
          
        }
      }
    })
  },
  onClose() {
    this.setData({ show: false });
  },

  goApproval(){
    wx.navigateTo({
      url: '../approval/approval',
    })
  },
  goSee(){
    wx.navigateTo({
      url: 'see/see',
    })
  },
  goUpdate(){
    let array = JSON.stringify(this.data.form)
    wx.navigateTo({
      url: 'add/add?type=update&array='+array,
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    var that = this ;
    UTIL.httpRequest(API.URL_GET_APPROVALITEMS + options.id, {method:'GET'}, {
      success: (res) => {
        let transList = res.data.transfers;
        let countMoney = that.data.countMoney
        transList.forEach((item,index) => {
          item.num = UTIL.convertToChinaNum(index+1)
          countMoney +=  parseInt(item.expenditureAmount);
        });
        res.data.transfers = transList
        
        that.setData({
          form:res.data,
          countMoney:countMoney
        });
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  back:function(){
    wx.navigateBack({
      delta: 1
    })
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})