// pages/handle/liist.js
import * as UTIL from '../../utils/util.js';
import * as API from '../../utils/API.js';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    active:"",
    pageTitle:"",
    // 待办列表
    todoList:[],
    // 已办列表
    doneList:[],
    // 已发起
    yfqList:[],
    // 已制单
    yzdList:[],
    //待办数量
    todoNum:0,
    //已办数量
    doneNum:0,
    //已发起数量
    yfqNum:0,
    //已制单数量
    yzdNum:0,
    index:0,
    array:["未提交","待审核","已审核","已挂起"],
    //字典
    transferType:[
      {"dictVale":1,"dictLabel":"村账户转账"},
      {"dictVale":2,"dictLabel":"公务卡转账"},
      {"dictVale":3,"dictLabel":"虚拟挂账"},
      {"dictVale":4,"dictLabel":"代管账户转账"},
      {"dictVale":5,"dictLabel":"母子转账"},
      {"dictVale":10,"dictLabel":"现金提现"},
      {"dictVale":11,"dictLabel":"现金使用"},
      {"dictVale":12,"dictLabel":"汇票支出"}
  ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({active:options.active})
    if(options.active==1||options.active==2){
      this.setData({pageTitle:"待办/已办"})
    }else{
      this.setData({pageTitle:"发起/制单"})
    }
    //查询待办
    this.getTaskList();
    //查询已办
    this.getTaskDoneList();
    //查询已发起
    this.getTransferList();
    this.getTransferList1();
    //查询已制单
    this.getTransferList2();
  },
  bindPickerChange:function(e){zhibob
    this.setData({index:e.detail.value});
  },
  switchTab:function(e){
    this.setData({
      active:e.currentTarget.dataset.gid
    })
},
  dictTranslate(d,value){
    let val = ""
    for(var index in d){
        if(d[index].dictVale==value){
          return val = d[index].dictLabel
        }
    } 
},
  getTaskList:function(e){
    let data = {
      pageNum:1,
      pageSize:10,
      orderByColumn:"A.ID_",
      isAsc:"desc",
      systemType:4,
      method:"GET"
    }
    UTIL.httpRequest(API.URL_GET_TASKLIST,data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({todoNum:res.total})
          this.setData({todoList:res.rows})
        }
      },	fail: (res) => {
        console.log(res);
      },
      complete: (res) => {
        console.log(res);
      }
    })
  },
  getTaskDoneList:function(e){
    let data = {
      pageNum:1,
      pageSize:10,
      orderByColumn:"A.ID_",
      isAsc:"desc",
      systemType:4,
      method:"GET"
    }
    UTIL.httpRequest(API.URL_GET_TASKDONELIST,data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({doneNum:res.total})
          this.setData({doneList:res.rows})
        }
      },	fail: (res) => {
        console.log(res);
      },
      complete: (res) => {
        console.log(res);
      }
    })
  },
  getTransferList:function(e){
    let data = {
      // pageNum:1,
      // pageSize:10,
      transferType:"1",
      auditStatus:"2",
      method:"GET",
      capitalExpenditureType:(this.data.index+1)
    }
    UTIL.httpRequest(API.URL_GET_TRANSFERLIST,data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          console.log(res);
          let a = this.data.yfqNum+res.total
          this.setData({yfqNum:a})
          this.setData({yfqList:res.rows})
        }
      },	fail: (res) => {
        console.log(res);
      },
      complete: (res) => {
        console.log(res);
      }
    })
  },
  getTransferList1:function(e){
    let data = {
      // pageNum:1,
      // pageSize:10,
      transferType:"1",
      auditStatus:"3",
      method:"GET"
    }
    UTIL.httpRequest(API.URL_GET_TRANSFERLIST,data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          console.log();
          let a = this.data.yfqNum+res.total
          this.setData({yfqNum:a})
          this.setData({yfqList:res.rows})
        }
      },	fail: (res) => {
        console.log(res);
      },
      complete: (res) => {
        console.log(res);
      }
    })
  },
  //已制单
  getTransferList2:function(e){
    let data = {
      // pageNum:1,
      // pageSize:10,
      transferType:"1",
      auditStatus:"0",
      method:"GET"
    }
    UTIL.httpRequest(API.URL_GET_TRANSFERLIST,data, {
      success: (res) => {
        if (res.code == API.SUCCESS_CODE) {
          this.setData({yzdNum:res.total})
          this.setData({yzdList:res.rows})
        }
      },	fail: (res) => {
        console.log(res);
      },
      complete: (res) => {
        console.log(res);
      }
    })
  },
  back:function(){
    wx.navigateBack({
      delta: 1
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})